Task = class.new();

function Task:constructor(_func, _time)

	-- Ensure that we were given a function to execute.
	if( type(_func) ~= "function" ) then
		return
	end

	self.fullTime = _time;	-- Save time between runs
	self.func = _func;		-- And the actual function to run
	self.timeLeft = _time;	-- And set our timer to full
end

function Task:update()
	-- Remove a small piece of time from our timer
	self.timeLeft = self.timeLeft - time.deltaTime();

	-- Now check if it is ready to run
	if( self.timeLeft < 0 ) then
		local ret = self.func();

		-- Reset it if requested to keep
		if( ret ) then
			self.timeLeft = self.fullTime;
		end

		-- Return our functions return value to the task queue
		return ret;
	end

	-- Return true to signal that we need to keep this task for now.
	return true;
end