include("task.lua");
TaskQueue = class.new();

function TaskQueue:constructor()
	-- This is our table for holding upcomming tasks
	self.tasks = {};
end

function TaskQueue:push(task, secsTilExecute)
	-- Make sure we were given a task object
	if( type(task) ~= "function" ) then
		error("Not given a function to execute for argument #1.", 2);
	end

	-- Need to also know how long until we execute
	if( type(secsTilExecute) ~= "number" ) then
		error("Argument #2 to TaskQueue:push() needs to be a number.", 2);
	end

	table.insert(self.tasks, Task(task, secsTilExecute));
end

function TaskQueue:update()
	for i,v in pairs(self.tasks) do
		local ret = v:update();

		-- Check if we need to remove this task
		if( not ret ) then
			table.remove(self.tasks, i);
		end
	end
end